const I = require('immutable-ext')
const {reduceTree} = require('./tree')

const toList = component =>
  reduceTree((acc, x) => acc.push(x), I.List(), component)

const variants = component =>
  toList(component)
  .filter(x => x.getIn(['annotations', 'variant']))
  .sortBy(n => n.get('id'), (a, b) => {
    if (a === 'base') return -1
    return a.localeCompare(b)
  })

const modifiers = component =>
  toList(component).filter(x => x.getIn(['annotations', 'modifier']))

module.exports = {variants, modifiers}
