const I = require('immutable-ext')
const Task = require('data.task')
const Either = require('data.either')

const concatContext = (context, html) =>
  I.List.of(context.get(0, ''), html, context.get(1, '')).fold('')

const assembleContext = exprts =>
  exprts.update('sections', sections =>
    sections.map(section =>
      section.update('items', items =>
        items.map(i => i.update('markup', html =>
          concatContext(exprts.get('context'), html))))))
  .get('sections')

const getMarkup = (askForMarkup, state) =>
  Either.of(comp => variant => askForMarkup(comp, variant))
  .ap(Either.fromNullable(state.getIn(['component', 'id'])))
  .ap(Either.fromNullable(state.getIn(['variant', 'id'])))
  .fold(() => Task.rejected('could not get markup'), x => x)
  .map(I.fromJS)
  .map(assembleContext)

module.exports = {getMarkup}
